property saveList, saveUrllist, SaveLocalList, mouseObj, viewObj, allList, inViewList, mouseClicked, worldSize, specialList, keyAction, worldSizeH, worldSizeV, mode, swapMode, deleteList, playNow, keyList, urlObj, controlObj, itchSprite, loadObj, speedControl, speedlimiter, memberName
global world, vitualObj, userMode, CD

on new me
  me.memberName = "worldParent"
  return me
end

on addDeletList me, obj
  add(deleteList, obj)
end

on makeIconsList me
  put EMPTY into field "icons"
  tempText = EMPTY
  repeat with y = 2 to the number of castLibs
    repeat with x = 1 to the number of castMembers of castLib y
      if item 2 of the name of member x of castLib y = "normal" then
        temp = char 3 of line 1 of the scriptText of member x of castLib y
        if temp = EMPTY then
          put item 1 of the name of member x of castLib y & ",0" & RETURN after tempText
          next repeat
        end if
        put item 1 of the name of member x of castLib y & "," & temp & RETURN after tempText
      end if
    end repeat
  end repeat
  put tempText into field "icons"
end

on makekeyList me
  keyList = [:]
  repeat with x = 1 to the number of lines in field "keys1"
    addProp(keyList, item 1 of line x of field "keys1", item 2 of line x of field "keys1")
  end repeat
  repeat with x = 1 to the number of lines in field "keys2"
    addProp(keyList, item 1 of line x of field "keys2", item 2 of line x of field "keys2")
  end repeat
end

on initalise me, prefList, prefURLList, localPrefList
  speedControl = the ticks
  speedlimiter = 2
  makekeyList()
  if userMode = #admin then
    makeIconsList(me)
  end if
  itchSprite = 112
  set the member of sprite itchSprite to member("itch")
  swapMode = 1
  mode = #map
  playNow = 0
  deleteList = []
  saveList = [#worldSizeH, #worldSizeV, #viewObj, #allList, #mouseObj]
  saveUrllist = [#urlObj]
  SaveLocalList = [#allList, #mouseObj]
  maxWorld = 30000
  vitualObj = new(script("virtualScreenParent"))
  loadObj = new(script("loadParent"))
  allList = [:]
  specialList = []
  keyAction = 0
  if listp(prefURLList) then
    tempL = getaProp(prefURLList, #urlObj)
    urlObj = new(script("urlParent"), tempL)
  else
    urlObj = new(script("urlParent"))
  end if
  if listp(prefList) then
    tempL = getaProp(prefList, #urlObj)
    worldSizeH = getaProp(prefList, #worldSizeH)
    worldSizeV = getaProp(prefList, #worldSizeV)
    tempL = getaProp(prefList, #viewObj)
    viewObj = new(script(getaProp(tempL, #name)), tempL)
    tempL = getaProp(prefList, #mouseObj)
    mouseObj = new(script(getaProp(tempL, #name)), tempL, viewObj)
    tempL = getaProp(prefList, #allList)
    repeat with x in tempL
      aName = getaProp(x, #name)
      anObj = new(script(aName), 0, 0, x, 0, 0)
      addProp(allList, anObj.uniqueID, anObj)
    end repeat
  else
    worldSizeH = 10000
    worldSizeV = 10000
    viewObj = new(script("viewparent"))
    mouseObj = new(script("mouseparent"))
  end if
  controlObj = new(script("controlParent"))
  if worldSizeH > maxWorld then
    worldSizeH = maxWorld
  end if
  if worldSizeV > maxWorld then
    worldSizeV = maxWorld
  end if
  repeat with x = 1 to count(localPrefList)
    bit = getAt(localPrefList, x)
    aName = getaProp(bit, #name)
    if getPropAt(localPrefList, x) = #mouseObj then
      tempL = getaProp(localPrefList, #mouseObj)
      mouseObj = new(script(getaProp(tempL, #name)), tempL, viewObj)
      next repeat
    end if
    if getPropAt(localPrefList, x) = #viewObj then
      tempL = getaProp(localPrefList, #viewObj)
      viewObj = new(script(getaProp(tempL, #name)), tempL)
      next repeat
    end if
    anObj = new(script(aName), 0, 0, bit, 0, 0)
    id = getPropAt(localPrefList, x)
    foundOne = getaProp(allList, id)
    if voidp(foundOne) then
      addProp(allList, anObj.uniqueID, anObj)
      next repeat
    end if
    setaProp(allList, anObj.uniqueID, anObj)
  end repeat
  repeat with anObj in allList
    addtoView(anObj)
  end repeat
  changeScale(viewObj, 0, mouseObj)
  if CD = 1 then
  else
    requestLoad(loadObj, ["preview2", "preview3", "preview4"])
  end if
  return me
end

on addthings me
  ran = 201
  divH = 500
  divV = 400
  WH = worldSizeH / divH
  WV = worldSizeV / divV
  repeat with x = 1 to WH
    repeat with y = 1 to WV
      rand = random(ran) - (ran / 2)
      doAction(me, "basic", (x * divH) + rand, (y * divV) + rand, 3, 0, "Hole")
    end repeat
  end repeat
end

on playIt me, link
  global returnPath, flashPath, linkMovie
  f = getObjfromUID(urlObj, link)
  if f = 0 then
    return 0
  end if
  returnPath = 0
  op = the pathName & f.originalpath
  temp = ChangeExtention(op, "dir")
  f.played = 1
  tempNam = f.fileNam
  flashPath = stripextension(tempNam)
  put flashPath && getPos(["ball", "vamp", "WImage"], flashPath)
  if getPos(["ball", "vamp", "WImage", "answerM", "flycycle", "xmasCard", "parrot", "3d"], flashPath) = 0 then
    linkMovie = 0
  else
    linkMovie = 1
  end if
  play movie "@/work_info/flashplayer.dir"
  return 1
  if f.mediatype = ".dcr" then
    returnPath = 0
    op = the pathName & f.originalpath
    temp = ChangeExtention(op, "dir")
    f.played = 1
    play movie temp
    return 1
  end if
  if f.mediatype = ".htm" then
    f.played = 1
    webpath = makeWebpath(f.originalpath)
    t = the pathName & webpath
    gotoNetPage(t)
  end if
  if the runMode = "Plugin" then
    if (f.mediatype = ".dir") or (f.mediatype = ".dcr") then
      returnPath = the pathName & the movieName
      f.played = 1
      gotoNetMovie(the pathName & f.originalpath)
      return 1
    end if
    if f.mediatype = ".htm" then
      f.played = 1
      webpath = makeWebpath(f.originalpath)
      t = the pathName & webpath
      gotoNetPage(t)
    end if
  end if
  if the runMode = "Projector" then
    if f.mediatype = ".htm" then
      returnPath = 0
      op = the pathName & f.originalpath
      temp = ChangeExtention(op, "dir")
      f.played = 1
      play movie temp
      return 1
    end if
    if f.mediatype = ".dcr" then
      returnPath = 0
      temp = the pathName & f.originalpath
      f.played = 1
      play movie temp
      return 1
    end if
    if f.mediatype = ".htm" then
      f.played = 1
      webpath = makeWebpath(f.originalpath)
      t = "file:///" & makeWebpath(the pathName) & webpath
      gotoNetPage(t)
      return 1
    end if
  end if
end

on deleteURL me, temp
  repeat with x in allList
    deleteURL(x, temp)
  end repeat
end

on update me
  if the ticks < speedControl then
    return 
  end if
  speedControl = the ticks + speedlimiter
  checkload(loadObj)
  if playNow <> 0 then
    a = playNow
    playNow = 0
    playIt(me, a)
  else
    repeat with x in deleteList
      delete(me, x)
    end repeat
    if swapMode = 0 then
      if mode = #map then
        mode = #edit
        backToEdit(me.controlObj)
      end if
    else
      if inside(point(the mouseH, the mouseV), the rect of sprite 1) then
        forceMove = 0
        if mode = #edit then
          set the member of sprite itchSprite to member("itch")
          InToEdit(me.controlObj)
          mode = #map
          cursor(200)
        end if
      else
        if mode = #map then
          if userMode = #admin then
            makeIconsList(me)
          end if
          set the member of sprite itchSprite to member("itchhome")
          mode = #edit
          backToEdit(me.controlObj)
        end if
      end if
    end if
    if mode = #map then
      updateMap(me)
    else
      cursor(-1)
    end if
    deleteList = []
  end if
end

on updateMap me
  checkMode(viewObj, mouseObj)
  if viewObj.mode = #scroll then
    setMouseMode(mouseObj, #scroll)
  else
    setMouseMode(mouseObj, #select)
  end if
  case keyAction of
    #zoomin:
      changeScale(viewObj, -0.5, mouseObj)
      setMouseMode(mouseObj, #zoomin)
    #zoomOut:
      changeScale(viewObj, 0.5, mouseObj)
      setMouseMode(mouseObj, #zoomOut)
  end case
  update(viewObj, mouseObj)
  update(mouseObj, viewObj)
  repeat with x in specialList
    updateSpecial(x)
  end repeat
  inViewList = buildViewList(viewObj)
  updateInview(me, inViewList)
  overObj = MouseOver(me, inViewList)
  if objectp(overObj) then
    if mouseClicked = 1 then
      ClickIntersects(overObj, mouseObj)
    end if
  else
    Display(controlObj, #empty)
  end if
  draw(viewObj, inViewList, mouseObj)
  mouseClicked = 0
end

on updateInview me, aList
  repeat with num = 1 to count(aList)
    obj = getAt(aList, num)
    updateInview(obj)
  end repeat
end

on MouseOver me, aList
  repeat with num = 1 to count(aList)
    obj = getAt(aList, num)
    if MouseOver(obj, mouseObj) then
      touching(mouseObj, obj)
      return obj
    end if
  end repeat
  return 0
end

on delete me, obj
  delete(obj)
  position = getPos(allList, obj)
  if position = 0 then
    return 
  end if
  deleteOne(allList, obj)
end

on reSetScreen me, h, v
  h = h - 125
  v = v + 130
  changeScale(viewObj, #reset, mouseObj)
  updateMap(me)
  jumpView2(viewObj, getMouseH(mouseObj), getMouseV(mouseObj), h, v)
  changeScale(viewObj, #reset, mouseObj)
  updateMap(me)
  jumpView2(viewObj, getMouseH(mouseObj), getMouseV(mouseObj), h, v)
  changeScale(viewObj, #reset, mouseObj)
  updateMap(me)
end

on RemoveSpecialList me, obj
  position = getOne(specialList, obj)
  if position = 0 then
    return 
  end if
  deleteOne(specialList, obj)
end

on keyDown me
  h = mouseObj.posH
  v = mouseObj.posV
  priority = value(char 1 of field "priority")
  speed = value(item 1 of line 1 of field "speed")
  test = the number of member (field "selected icon" & ",normal")
  if test = -1 then
    aMem = "blank"
  else
    aMem = field("selected icon")
  end if
  doAction(me, getaProp(keyList, the key), h, v, priority, speed, aMem)
end

on doAction me, match, h, v, priority, speed, aMem
  case match of
    "link":
      if userMode <> #admin then
        return 
      end if
      anObj = new(script("dotlineDotParent"), h, v, 0, "internal", "link", "internal", "H")
      setPriority(anObj, priority)
      setSpeed(anObj, speed)
      addProp(allList, anObj.uniqueID, anObj)
      addtoView(anObj)
    "work":
      if userMode <> #admin then
        return 
      end if
      anObj = new(script("BrainDot1"), h, v, 0, "internal", aMem)
      setPriority(anObj, priority)
      addProp(allList, anObj.uniqueID, anObj)
      setSpeed(anObj, speed)
      addtoView(anObj)
    "basic":
      anObj = new(script("marker1"), h, v, 0, "internal", aMem)
      setPriority(anObj, priority)
      addProp(allList, anObj.uniqueID, anObj)
      setSpeed(anObj, speed)
      addtoView(anObj)
    "gravity":
      if userMode <> #admin then
        return 
      end if
      anObj = new(script("gravity"), h, v, 0, "internal", aMem)
      setPriority(anObj, priority)
      addProp(allList, anObj.uniqueID, anObj)
      setSpeed(anObj, speed)
      addtoView(anObj)
    "lock space":
      if userMode <> #admin then
        return 
      end if
      anObj = new(script("lockspace"), h, v, 0, "internal", aMem)
      setPriority(anObj, priority)
      addProp(allList, anObj.uniqueID, anObj)
      setSpeed(anObj, speed)
      addtoView(anObj)
    "bug":
      anObj = new(script("bugParent"), h, v, 0, "internal", aMem)
      setPriority(anObj, priority)
      addProp(allList, anObj.uniqueID, anObj)
      setSpeed(anObj, speed)
      addtoView(anObj)
    "searchUrl":
      if userMode <> #admin then
        return 
      end if
      search(urlObj)
    "save layout":
      if userMode <> #admin then
        return 
      end if
    "zoom in":
      keyAction = #zoomin
    "zoom Out":
      keyAction = #zoomOut
    "edit/scroll":
      if userMode <> #admin then
        return 
      end if
      if swapMode = 1 then
        swapMode = 0
      else
        swapMode = 1
      end if
  end case
end

on keyUp me
  keyAction = 0
end
