property saveList, ancestor, inputList, mode, groupName, libName, memberName
global world, vitualObj, userMode

on new me, h, v, aList, libNam, groupNam
  me.memberName = "marker1"
  saveList = [#ancestor, #mode, #libName, #groupName]
  if listp(aList) then
    tempL = getaProp(aList, #ancestor)
    aName = getaProp(tempL, #name)
    me.ancestor = new(script(aName), h, v, tempL)
    me.mode = getaProp(aList, #mode)
    me.mode = #normal
    me.libName = getaProp(aList, #libName)
    me.groupName = getaProp(aList, #groupName)
    changeMem(ancestor, groupName & "," & #normal)
  else
    me.ancestor = new(script("partParent"), h, v)
    me.mode = #normal
    me.libName = libNam
    me.groupName = groupNam
    changeMem(ancestor, groupName & "," & #normal)
  end if
  inputList = []
  return me
end

on addtoView me
  addnewObj(vitualObj, me.posH, me.posV, me)
end

on updateSpecial me, h, v
  case mode of
    #movable:
      h = integer(world.mouseObj.posH)
      v = integer(world.mouseObj.posV)
      sortMove(me, h, v)
  end case
end

on sortMove me, h, v
  obj = me.madeFromObj
  if objectp(obj) then
    move(me.madeFromObj, me, h, v)
  else
    move(me, h, v)
  end if
end

on move me, mH, mV
  if mH < 1 then
    mH = 1
  end if
  if mV < 1 then
    mV = 1
  end if
  newH = mH
  newV = mV
  move(vitualObj, me.posH, me.posV, me, newH, newV)
  me.posH = newH
  me.posV = newV
end

on updateInview me
  temp = makeChoice(me)
  inputList = []
  return temp
end

on makeChoice me
  if me.Lock = 1 then
    return 
  end if
  case me.mode of
    #normal:
      if getPos(inputList, #touching) <> 0 then
        changeMem(me, me.groupName & "," & #normal)
        Display(world.controlObj, #normal, me)
        return 
      end if
  end case
end

on MouseOver me, mouseObj
  if intersect(getrect(mouseObj), getrect(me)) <> rect(0, 0, 0, 0) then
    inputList = [#touching]
    if me.Lock then
    else
    end if
    return 1
  end if
  return 0
end

on ClickIntersects me, mouseObj
  if intersect(getrect(mouseObj), getrect(me)) <> rect(0, 0, 0, 0) then
    if userMode = #admin then
      if the controlDown then
        Lock(me)
        return 1
      end if
      if me.Lock = 1 then
        return 
      end if
      if the commandDown then
        clickMove(me)
        return 1
      end if
      if the optionDown then
        optionDown(me)
        return 1
      end if
    else
    end if
    return 1
  else
    return 0
  end if
end

on optionDown me
end

on clickMove me
  if me.mode = #movable then
    me.mode = #normal
    add(inputList, #none)
    RemoveSpecialList(world, me)
  else
    me.mode = #movable
    add(world.specialList, me)
    add(inputList, #move)
  end if
end
