property saveList, mem, memRect, posH, posV, type, madeFromObj, Lock, link, played, text, priority, uniqueID, SaveLocalList, saveLocalFlag, speed, nextchange, changeFlag, memberName
global world, vitualObj, worldMode

on new me, h, v, aList
  me.memberName = "partParent"
  saveList = [#posH, #posV, #Lock, #link, #played, #text, #uniqueID, #priority, #speed]
  saveLocalFlag = 0
  me.played = 0
  if listp(aList) then
    posH = getaProp(aList, #posH)
    posV = getaProp(aList, #posV)
    me.Lock = getaProp(aList, #Lock)
    me.link = getaProp(aList, #link)
    me.text = getaProp(aList, #text)
    me.uniqueID = getaProp(aList, #uniqueID)
    if voidp(me.uniqueID) then
      uniqueID = getUniqueID()
    end if
    me.priority = getaProp(aList, #priority)
    if voidp(me.priority) then
      priority = 5
    end if
    me.speed = getaProp(aList, #speed)
    if voidp(me.speed) then
      speed = 0
    end if
  else
    uniqueID = getUniqueID()
    link = 0
    posH = h
    posV = v
    text = " "
    priority = 5
    speed = 0
    me.Lock = 0
  end if
  changeFlag = 1
  me.played = getPropfromUID(world.urlObj, link, #played)
  me.mem = member("basic,normal")
  changeMem(me, member("basic,normal"))
  madeFromObj = 0
  return me
end

on changeMem me, nam
  if nam contains "lgprod" then
  end if
  if the number of member nam = -1 then
    return 
  end if
  if mem.name = nam then
    if changeFlag = 0 then
      exit
    end if
    if member(me.mem.number + 1).type <> #empty then
      if member(me.mem.number + 1).name = me.mem.name then
        me.mem = member(me.mem.number + 1)
        setMem(me)
      else
        me.mem = member(nam)
        setMem(me)
      end if
    else
      me.mem = member(nam)
      setMem(me)
    end if
  else
    me.mem = member(nam)
    setMem(me)
  end if
end

on setMem me
  me.type = mem.type
  Arect = member(mem).rect / 2
  memRect = offset(member(mem).rect, -Arect.width, -Arect.height)
end

on Lock me
  if me.Lock = 1 then
    me.Lock = 0
  else
    me.Lock = 1
  end if
end

on updateSpecial me
end

on updateInview me
end

on MouseOver me, mouseObj
  return 0
end

on ClickIntersects me, mouseObj
  return 0
end

on draw me, sp, scale, offH, offV
  set the member of sprite sp to mem
  RectInWorld = offset(memRect, posH, posV)
  offsetToWindow = RectInWorld - rect(point(offH, offV), point(offH, offV))
  set the rect of sprite sp to offsetToWindow / scale
  if nextchange < the ticks then
    nextchange = the ticks + (speed * 2)
    changeFlag = 1
  else
    changeFlag = 0
  end if
  return sp + 1
end

on getrect me
  return offset(memRect, posH, posV)
end

on delete me
  obj = me.madeFromObj
  if objectp(obj) then
    delete(me.madeFromObj, me)
  else
    delete(vitualObj, me)
  end if
end

on deleteURL me, temp
  if me.link = temp then
    me.link = 0
  end if
end

on setPriority me, num
  me.priority = num
end

on setSpeed me, aspeed
  speed = aspeed
end
