property saveList, obj1, obj2, objLine, memberName, uniqueID, saveLocalFlag, mem
global world, vitualObj

on new me, h, v, aList, dotlibNam, dotgroupNam, linelibNam, linegroupNam
  me.memberName = "dotlineDotParent"
  saveList = [#obj1, #obj2, #objLine, #uniqueID]
  saveLocalFlag = 0
  if listp(aList) then
    me.uniqueID = getaProp(aList, #uniqueID)
    if voidp(me.uniqueID) then
      uniqueID = getUniqueID()
    end if
    tempL = getaProp(aList, #obj1)
    aName = getaProp(tempL, #name)
    obj1 = new(script(aName), h, v, tempL, dotlibNam, dotgroupNam)
    obj1.madeFromObj = me
    tempL = getaProp(aList, #obj2)
    aName = getaProp(tempL, #name)
    obj2 = new(script(aName), h + 80, v + 80, tempL, dotlibNam, dotgroupNam)
    obj2.madeFromObj = me
    tempL = getaProp(aList, #objLine)
    aName = getaProp(tempL, #name)
    objLine = new(script(aName), obj1, obj2, tempL, linelibNam, linegroupNam)
    objLine.madeFromObj = me
  else
    uniqueID = getUniqueID()
    obj1 = new(script("BrainDotjump"), h, v, 0, dotlibNam, dotgroupNam)
    obj1.madeFromObj = me
    obj2 = new(script("BrainDotjump"), h + 80, v + 80, 0, dotlibNam, dotgroupNam)
    obj2.madeFromObj = me
    objLine = new(script("BrainLine"), obj1, obj2, 0, linelibNam, linegroupNam)
    objLine.madeFromObj = me
  end if
  mem = member("link,normal")
  return me
end

on addtoView me
  addtoView(obj1)
  addtoView(obj2)
  addtoView(objLine)
end

on deleteURL x, temp
  deleteURL(objLine, temp)
  deleteURL(obj1, temp)
  deleteURL(obj2, temp)
end

on delete me
  delete(objLine)
  delete(vitualObj, obj1)
  delete(vitualObj, obj2)
  position = getPos(world.allList, me)
  if position = 0 then
    return 
  end if
  deleteOne(world.allList, me)
end

on move me, fromPart, h, v
  oldPosH = fromPart.posH
  oldPosV = fromPart.posV
  move(fromPart, h, v)
  newPosH = integer(fromPart.posH)
  newPosV = integer(fromPart.posV)
  if fromPart = obj1 then
    move(objLine, oldPosH, oldPosV, newPosH, newPosV, obj2)
  else
    move(objLine, oldPosH, oldPosV, newPosH, newPosV, obj1)
  end if
end

on jump me, fromPart
  if fromPart = obj1 then
    jumpView2(world.viewObj, obj1.posH, obj1.posV, obj2.posH, obj2.posV)
  else
    jumpView2(world.viewObj, obj2.posH, obj2.posV, obj1.posH, obj1.posV)
  end if
end

on setPriority me, num
  obj1.priority = num
  obj2.priority = num
end

on setSpeed me, aspeed
  obj1.speed = aspeed
  obj2.speed = aspeed
end
