global world, counter, vitualObj, maxWorldH, maxWorldV, worldMode, userMode, saveMode, playSpeed, Gstate, CD

on startMovie
  clearGlobals()
  CD = 1
  if CD = 1 then
    tell the stage
      posWind(608, 300)
    end tell
  end if
  go(1)
  updateStage()
  getspeed()
end

on positionabove
end

on getspeed
  a = the ticks
  repeat with x = 1 to 10000
  end repeat
  put the ticks - a
end

on startLingo
  Gstate = #go
  userMode = #viewer
  if the controlDown or (userMode = #admin) then
    put "enter password" into field "password"
    put EMPTY into field "invisablepassword"
    go("password")
    if userMode = #admin then
      go("admin")
    end if
    updateStage()
  else
    go("start")
    saveMode = #saveLocal
    updateStage()
    worldMode = #localPrefs
    startspace()
  end if
end

on waitOn aMem
  repeat while member(aMem).mediaReady
  end repeat
end

on startspace
  if userMode = #admin then
    go("playAdmin")
  else
    go("play")
  end if
  cursor(200)
  updateStage()
  if CD = 1 then
    initUtilities()
    tell the stage
      readText("itchLocal")
    end tell
    t = the result
    localPrefList = value(t)
    prefList = value(readfromField())
    prefURLList = value(field("saveURLList"))
    world = new(script("worldParent"))
    initalise(world, prefList, prefURLList, localPrefList)
    return 
  end if
  if voidp(getPref("masterURLlist")) then
    SetPref("masterURLlist", field("saveURLList"))
  end if
  if voidp(getPref("localitch")) then
    SetPref("Localitch", string([:]))
  end if
  initUtilities()
  localPrefList = [:]
  case worldMode of
    #localPrefs:
      if the runMode = "plugin" then
        prefList = value(readfromField())
      else
        prefList = value(readfromField())
      end if
      t = getPref("localitch")
      if t = EMPTY then
        t = "[:]"
      end if
      localPrefList = value(t)
      prefURLList = value(field("saveURLList"))
    #masterprefs:
      if the runMode = "Plugin" then
        prefList = value(readfromField())
      else
        prefList = value(readfromField())
      end if
      prefURLList = value(field("saveURLList"))
    #newspace:
      storeInField(EMPTY)
      prefList = EMPTY
      prefURLList = value(field("saveURLList"))
  end case
  world = new(script("worldParent"))
  initalise(world, prefList, prefURLList, localPrefList)
end

on stopMovie
  if CD = 1 then
    temp = makeLocalPrefs()
    tell the stage
      saveText("itchLocal", temp)
    end tell
    saveLocal(world.urlObj)
    return 
  end if
  unsetCasts(world.loadObj)
  if userMode = #admin then
    tempURL = string(save(world, #saveUrllist))
    put tempURL into field "saveURLList"
    SetPref("masterURLlist", tempURL)
    case saveMode of
      #saveLocal:
        localP = makeLocalPrefs()
        SetPref("Localitch", string(localP))
      #saveMaster:
        prefList = string(save(world, #saveList))
        storeInField(prefList)
        saveFile(prefList)
        SetPref("MasterItchPrefs", prefList)
        SetPref("itchLink", string([:]))
      #saveNew:
        prefList = string(save(world, #saveList))
        storeInField(prefList)
        saveFile(prefList)
        SetPref("MasterItchPrefs", prefList)
        SetPref("Localitch", string([:]))
        SetPref("itchLink", string([:]))
    end case
  else
    localP = makeLocalPrefs()
    SetPref("Localitch", string(localP))
    saveLocal(world.urlObj)
  end if
end

on readfromField
  tempstring = EMPTY
  counter = 0
  repeat while 1
    counter = counter + 1
    if the number of member ("saveList" & counter) = -1 then
      exit repeat
    end if
    put field("saveList" & counter) after tempstring
  end repeat
  return tempstring
end

on storeInField varString
  sizinlist = 30000
  counter = 0
  repeat while 1
    num = the number of chars in varString
    counter = counter + 1
    if the number of member ("saveList" & counter) = -1 then
      exit repeat
    end if
    if num > 0 then
      put char 1 to sizinlist of varString into field ("saveList" & counter)
      delete char 1 to sizinlist of varString
      next repeat
    end if
    put EMPTY into field ("saveList" & counter)
  end repeat
end

on state type
  Gstate = type
end

on updateWorld
  update(world)
end

on keyDown
  if objectp(world) then
    keyDown(world)
  end if
  if (the key = "q") or (the key = "Q") then
    tell the stage
      playDone()
    end tell
  end if
end

on keyUp
  if objectp(world) then
    keyUp(world)
  end if
end

on mouseDown
  if objectp(world) then
    world.mouseClicked = 1
  end if
end

on save obj, saveType
  l = [#name: getName(obj)]
  f = getaProp(obj, saveType)
  if voidp(f) then
    return 
  end if
  count = count(f)
  repeat with x = 1 to count
    p = getAt(f, x)
    if voidp(p) then
      next repeat
    end if
    v = getaProp(obj, p)
    if ilk(v) = #instance then
      v = save(v, saveType)
    else
      if ilk(v) = #list then
        c = count(v)
        repeat with a = 1 to c
          k = getAt(v, a)
          if ilk(k) = #instance then
            setAt(v, a, save(k, saveType))
          end if
        end repeat
      end if
      if ilk(v) = #propList then
        c = count(v)
        repeat with a = 1 to c
          k = getAt(v, a)
          if ilk(k) = #instance then
            setAt(v, a, save(k, saveType))
          end if
        end repeat
      end if
    end if
    addProp(l, p, v)
  end repeat
  return l
end

on getName obj
  t = obj.memberName
  return t
end

on putTicks num
  global tim
  put the ticks - tim + 0.0 && num & RETURN after playSpeed
end

on st
  global tim
  tim = the ticks
end

on makeLocalPrefs
  t = [:]
  repeat with x in world.allList
    if x.saveLocalFlag then
      temp = save(x, #saveList)
      addProp(t, x.uniqueID, temp)
    end if
  end repeat
  temp = save(world.viewObj, #saveList)
  addProp(t, #viewObj, temp)
  temp = save(world.mouseObj, #saveList)
  addProp(t, #mouseObj, temp)
  return t
end
