property loadList, castNamList, castCounter, maxCount, requestList, currenID
global world

on new me
  loadList = []
  castNamList = []
  castCounter = 3
  maxCount = the number of castLibs
  requestList = []
  return me
end

on requestLoad me, aList
  if the runMode = "Author" then
    repeat with x in aList
      castLib(castCounter).fileName = the pathName & x & ".cst"
      castCounter = castCounter + 1
    end repeat
    redoicons()
  else
    repeat with x in aList
      add(requestList, the pathName & x & ".cct")
    end repeat
    LinkCast(me)
  end if
end

on checkload me
  if count(requestList) = 0 then
    return 
  end if
  if netDone(currenID) then
    LinkCast(me)
  end if
end

on LinkCast me
  aName = getAt(requestList, 1)
  castLib(castCounter).fileName = aName
  updateStage()
  if castLib(castCounter).fileName = aName then
    castCounter = castCounter + 1
    deleteAt(requestList, 1)
    if count(requestList) = 0 then
      return 
    end if
    currenID = preloadNetThing(getAt(requestList, 1))
    redoicons(me)
  end if
end

on CashCast me, nam
  if the runMode = "Author" then
    castLib(castCounter).fileName = nam & ".cst"
    castCounter = castCounter + 1
    redoicons()
  else
    if castCounter > maxCount then
      return 
    end if
    add(castNamList, the pathName & nam & ".cct")
  end if
end

on unsetCasts me
  if the runMode = "Author" then
    repeat with num = 2 to maxCount
      castLib(num).fileName = the pathName & "empty" & ".cst"
      updateFrame()
    end repeat
  end if
end

on redoicons me
  a = world.allList
  repeat with x in a
    if x.mem.name = "basic,normal" then
      changeMem(x, x.groupName & "," & x.mode)
    end if
  end repeat
end
