property displayList, lastObj, aDelay, currentType, selectedObj, memberName
global world, vitualObj, userMode

on new me
  init(me)
  return me
end

on init me
  me.memberName = "controlParent"
  aDelay = 0
  mode = #normal
  displayList = [:]
  addProp(displayList, #normal, new(script("displayNormal")))
  addProp(displayList, #displayURL, new(script("displayURL")))
  lastObj = 0
  currentType = 0
end

on Display me, type, obj
  if obj <> lastObj then
    lastObj = obj
    if voidp(obj) then
      put field("zoom info") into field "box1"
      selectedObj = 0
      if userMode = #admin then
        go("playAdmin")
      end if
      return 
    else
      currentType = type
      selectedObj = obj
      case type of
        #normal:
          Display(getProp(displayList, #normal), obj)
      end case
    end if
  end if
end

on actOn me, aCommand, info
  if not objectp(selectedObj) then
    return 
  end if
  case aCommand of
    "deleteObj":
      addDeletList(world, selectedObj)
    "ViewURL":
      Display(getProp(displayList, #displayURL), selectedObj)
    "addURL":
      addURL(getProp(displayList, #displayURL), selectedObj)
    "changeURL":
      changeURL(getProp(displayList, #displayURL), selectedObj, info)
    "refresh":
      Display(getProp(displayList, #displayURL), selectedObj)
    "edit":
      if the editableText of sprite 120 = 1 then
        set the editableText of sprite 120 to 0
      else
        set the editableText of sprite 120 to 1
      end if
  end case
end

on backToEdit me
  if not objectp(selectedObj) then
    return 
  end if
  put getURLList(world.urlObj) into field "urlList"
end

on InToEdit me
  if not objectp(selectedObj) then
    return 
  end if
  selectedObj.text = the text of field "box1"
  put EMPTY into field "urlList"
  setPriority(selectedObj, value(char 1 of field "priority"))
  setSpeed(selectedObj, value(char 1 of field "speed"))
end
