on DrawLine p1, p2, sp, scale
  temp = p1 - p2
  if ((temp.locH > 0) and (temp.locV > 0)) or ((temp.locH < 0) and (temp.locV < 0)) then
    drawTheLine(p1, p2, "D", sp, scale)
    exit
  end if
  if ((temp.locH < 0) and (temp.locV > 0)) or ((temp.locH > 0) and (temp.locV < 0)) then
    drawTheLine(p1, p2, "U", sp, scale)
    exit
  end if
  if temp.locH = 0 then
    drawTheLine(p1, p2, "V", sp, scale)
    exit
  end if
  if temp.locV = 0 then
    drawTheLine(p1, p2, "H", sp, scale, scale)
    exit
  end if
end

on drawTheLine p1, p2, mem, sp, scale
  puppetSprite(sp, 1)
  set the member of sprite sp to member(mem)
  if mem = "H" then
    t = rect(p2, p1 + point(0, 1))
    set the rect of sprite sp to t
    exit
  end if
  if mem = "V" then
    t = rect(p2, p1 + point(1, 0))
    set the rect of sprite sp to t
    exit
  end if
  l = integer(p1.locH / scale)
  t = integer(p1.locV / scale)
  r = integer(p2.locH / scale)
  b = integer(p2.locV / scale)
  set the rect of sprite sp to rect(l, t, r, b)
end

on lineInRect Arect, p1, p2
  if Arect.left <= p1.locH then
    if (p2.locH <= Arect.right) and (Arect.bottom <= p1.locV) then
      if p2.locV <= Arect.top then
        return 1
      end if
    end if
  end if
  return 0
end
