property saveList, ancestor, memberName
global world, vitualObj

on new me, h, v, aList, libNam, groupNam
  me.memberName = "gravity"
  saveList = [#ancestor]
  if listp(aList) then
    tempL = getaProp(aList, #ancestor)
    aName = getaProp(tempL, #name)
    me.ancestor = new(script(aName), h, v, tempL, libNam, groupNam)
  else
    me.ancestor = new(script("marker1"), h, v, 0, libNam, groupNam)
  end if
  return me
end

on addtoView me
  addnewObj(vitualObj, me.posH, me.posV, me)
end

on updateInview me
  screenObj = world.viewObj
  center = getcenterPoint(screenObj)
  viewH = getAt(center, 1)
  viewV = getAt(center, 2)
  distance = getDistNum(viewH, viewV, me.posH, me.posV)
  speed = 20
  if distance < speed then
    centerOBj(screenObj, me)
  else
    screenObj.alterH = screenObj.alterH + ((me.posH - viewH) / distance * speed)
    screenObj.alterV = screenObj.alterV + ((me.posV - viewV) / distance * speed)
  end if
  makeChoice(me)
  me.inputList = []
end
