property saveList, ancestor, memberName
global world, vitualObj, userMode

on new me, h, v, aList, libNam, groupNam
  me.memberName = "bugParent"
  saveList = [#ancestor]
  if listp(aList) then
    tempL = getaProp(aList, #ancestor)
    aName = getaProp(tempL, #name)
    me.ancestor = new(script(aName), h, v, tempL, libNam, groupNam)
  else
    me.ancestor = new(script("marker1"), h, v, 0, libNam, groupNam)
  end if
  me.inputList = []
  return me
end

on addtoView me
  addnewObj(vitualObj, me.posH, me.posV, me)
end

on updateInview me
  h = me.posH + (random(5) - 3)
  v = me.posV + (random(5) - 3)
  sortMove(me, h, v)
  makeChoice(me)
  me.inputList = []
end

on makeChoice me
  if me.Lock then
    return 
  end if
  case ancestor.mode of
    #normal:
      if getPos(me.inputList, #clicked) <> 0 then
        return 
      end if
      if getPos(me.inputList, #touching) <> 0 then
        changeMem(me, me.groupName & "," & #touching)
        Display(world.controlObj, #normal, me)
        return 
      end if
      if me.played then
      else
      end if
    #clicked:
      if getPos(me.inputList, #clicked) <> 0 then
        return 
      end if
  end case
end

on ClickIntersects me, mouseObj
  if intersect(getrect(mouseObj), getrect(me)) <> rect(0, 0, 0, 0) then
    if userMode = #admin then
      if the controlDown then
        Lock(me)
        return 1
      end if
      if me.Lock = 1 then
        return 
      end if
      if the commandDown then
        clickMove(me)
        return 1
      end if
      if the optionDown then
        optionDown(me)
        return 1
      end if
    else
      add(me.inputList, #clicked)
    end if
    return 1
  else
    return 0
  end if
end

on clickMove me
  if me.mode = #movable then
    me.mode = #normal
    add(me.inputList, #none)
    RemoveSpecialList(world, me)
  else
    me.mode = #movable
    add(world.specialList, me)
    add(me.inputList, #move)
  end if
end

on optionDown me
end
